module MatchOptimization
where

import StrategyOptimization
import Match
import PaperRockScissors
import Cheat

-------------------------------------------------------
-- Durch das festlegen von zwei Strategien im Strategy-
-- Tupel und einem Int-Wert, der die Anzahl der Runden
-- angibt, knnen mehrere Spielrunden gesplielt werden
-------------------------------------------------------
match :: Int -> (Strategy, Strategy) -> (Int, Int)
match n = total . map score . take n . rounds

-------------------------------------------------------
-- Liefert eine Liste von Runden, die aus den Strategien
-- berechnet werden
-------------------------------------------------------
rounds :: (Strategy, Strategy) -> [Round]
rounds (f, g) =	zip xs ys
		where
		xs = f ys
		ys = g xs