module StrategyOptimization
where

import Strategy
import PaperRockScissors

type Strategy = [Move] -> [Move]

-------------------------------------------------------
-- Strategie, die den vorherigen Zug des Gegners wieder-
-- holt
-------------------------------------------------------
recipro :: Strategy
recipro ms = Rock : ms

-------------------------------------------------------
-- Strategie, die den vorherigen Zug des Gegners wieder-
-- holt
-------------------------------------------------------
smart :: Strategy
smart ms = Rock : map choose (counts ms)

-------------------------------------------------------
-- Ausnutzung von scanl um die Anzahl der unterschied-
-- liche Spielzuege zu berechnen
-------------------------------------------------------
counts :: [Move] -> [(Int, Int, Int)]
counts = tail . scanl (+++) (0, 0, 0)